<?php
namespace Claromentis\News\Comments;

$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] ?: array()) + array("_d0c05b93b1b39" . "30a232616bd5f5" . "73345" => base64_decode("bWVudS5hcHAubmV3" . "cw=="), "_a591754a8ddcdbda9" . "c80f1db4d911e14" => base64_decode("aXNf" . "bnVs" . "bA=="), "nam" . "e" => base64_decode("bmFtZQ" . "=="), "_6e1e715e87d93e333725c" . "e6b91bc6b09" => base64_decode("L25ld" . "3M="), "_e06da3f" . "fba2e84b" . "8e6f94bd" . "2d6ca3c5" . "2" => base64_decode("Y3JlYXRl" . "X2ludGVy" . "bmFsX2xp" . "bms="), "_0c5123aa744f69bbc0e8b3ea2f6e84" . "7d" => base64_decode("bG1" . "zZw" . "=="), "_559824e0ac2e0" . "f7e96c810473f7" . "8f5fe" => base64_decode("L25" . "ld3" . "Mv"), "_f784524629d9404cd62ba9e1475d" . "3bc3" => base64_decode("b2JqZW" . "N0X25h" . "bWU="), "ur" . "l" => base64_decode("dX" . "Js"));
use Claromentis\Comments\CommentableInterface;
use Claromentis\Comments\CommentLocationInterface;
use Claromentis\Comments\CommentsRepository;
use Claromentis\Comments\Model\Comment;
use Claromentis\Comments\Notification\Notification;
use Claromentis\Comments\SupportedOptions;
use Claromentis\Core\DAL;
use Claromentis\Comments\Rights;
use Claromentis\Core\Security\SecurityContext;
use Claromentis\Core\Services;
use NewsItem;
use NewsItemBase;






class CommentableNews implements CommentableInterface, CommentLocationInterface
{
    private $news_id;
    
    
    
    
    private $news_item;
    
    
    
    
    
    
    public static function CreateFromObject(NewsItem $_60378eae7533ef2a18e2cf710db06291)
    {
        $_68ffaaa31e3ba49ed9d6159fbee9f043 = new static();
        $_68ffaaa31e3ba49ed9d6159fbee9f043->news_item = $_60378eae7533ef2a18e2cf710db06291;
        $_68ffaaa31e3ba49ed9d6159fbee9f043->news_id = $_60378eae7533ef2a18e2cf710db06291->GetId();
        return $_68ffaaa31e3ba49ed9d6159fbee9f043;
    }
    public static function DeleteFromObject(NewsItem $_60378eae7533ef2a18e2cf710db06291)
    {
        $_5e1e8bdeb7dc6725dab2802927e4f193 = self::CreateFromObject($_60378eae7533ef2a18e2cf710db06291);
        
        
        $_d494fa2121915ac5ef3cbbab4c40bef2 = Services::I()->{CommentsRepository::class};
        $_d494fa2121915ac5ef3cbbab4c40bef2->DeleteAllForObject($_5e1e8bdeb7dc6725dab2802927e4f193);
    }
    
    
    
    
    
    
    
    
    
    public function Load($id, $_4a033bdf0ce701c6255d5238633ab2d0 = array())
    {
        $this->news_id = $id;
        $this->news_item = null;
    }
    
    
    
    
    
    
    public function GetAggregationObject()
    {
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_a591754a8ddcdbda9c80" . "f1db4d911e14"]($this->news_item)) {
            $this->news_item = new \NewsItem($this->news_id);
        }
        return $this->news_item;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function UserHasPermission(SecurityContext $context, $perms, Comment $comment = null)
    {
        $_a916d928b8442d37068d2cfd8aaf244d = $this->GetAggregationObject();
        if (!$_a916d928b8442d37068d2cfd8aaf244d->UserHasPermission(PERM_VIEW)) {
            return false;
        }
        if ($perms != Rights::PERM_VIEW && !$_a916d928b8442d37068d2cfd8aaf244d->IsCommentingEnabled()) {
            return false;
        }
        if (($perms & Rights::PERM_EDIT) == Rights::PERM_EDIT || ($perms & Rights::PERM_DELETE) == Rights::PERM_DELETE) {
            if (!$_a916d928b8442d37068d2cfd8aaf244d->UserHasPermission(PERM_APPROVE)) {
                if ($comment && (int) $comment->user_id !== $context->GetUserId()) {
                    return false;
                }
            }
        }
        return true;
    }
    
    
    
    
    
    
    
    public function GetOptions()
    {
        return [SupportedOptions::REPLIES => true, SupportedOptions::LIKES => true, SupportedOptions::ATTACHMENTS => true];
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function Notify(Comment $comment, Notification $_0dfb4a13f8c551dff0f061eebc847961)
    {
        $_0dfb4a13f8c551dff0f061eebc847961->type = \IMessage::TYPE_NEWS;
        $_60378eae7533ef2a18e2cf710db06291 = $this->GetAggregationObject();
        $_0dfb4a13f8c551dff0f061eebc847961->AddTemplateValues([$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_f784524629d9404cd62" . "ba9e1475d3bc3"] => $_60378eae7533ef2a18e2cf710db06291->GetTitle()]);
        $_fa7526ba4ccc308fe61186445986ceaa = $_0dfb4a13f8c551dff0f061eebc847961->GetRecipients();
        
        
        if ($_60378eae7533ef2a18e2cf710db06291->owner_id != $comment->user_id) {
            if (!isset($_fa7526ba4ccc308fe61186445986ceaa[$_60378eae7533ef2a18e2cf710db06291->owner_id])) {
                $_fa7526ba4ccc308fe61186445986ceaa[] = $_60378eae7533ef2a18e2cf710db06291->owner_id;
            }
        }
        $_0dfb4a13f8c551dff0f061eebc847961->SetRecipients($_fa7526ba4ccc308fe61186445986ceaa);
        $_0dfb4a13f8c551dff0f061eebc847961->Send();
    }
    public function GetBreadcrumbs(int $object_id)
    {
        $_60378eae7533ef2a18e2cf710db06291 = NewsItemBase::Get($object_id);
        return [[$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["n" . "a" . "m" . "e"] => $GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_0c5123aa744f69bbc0" . "e8b3ea2f6e847d"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_d0c05b93b1b3930a2" . "32616bd5f573345"]), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["ur" . "l"] => $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_e06da3ffba2e84b8e6f94bd" . "2d6ca3c52"]($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_6e1e715e87d93e333725ce" . "6b91bc6b09"])], [$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["nam" . "e"] => $_60378eae7533ef2a18e2cf710db06291->GetTitle(), $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["ur" . "l"] => $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_e06da3ffba2" . "e84b8e6f94bd" . "2d6ca3c52"]($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_559824e0ac2e0f7e96c8104" . "73f78f5fe"] . $object_id)]];
    }
}